diff -ur mpd-5.6/src/radius.c mpd-5.6-lutz/src/radius.c
--- mpd-5.6/src/radius.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/radius.c	2013-05-03 22:05:22.000000000 +0200
@@ -201,7 +201,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_USER_NAME: %s", 
 	auth->info.lnkname, auth->params.authname));
     if (rad_put_string(auth->radius.handle, RAD_USER_NAME, auth->params.authname) == -1) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME failed %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME failed %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	auth->status = AUTH_STATUS_FAIL;    
 	return;
@@ -217,7 +217,7 @@
 	    auth->info.lnkname, mlen, auth->params.eapmsg_len));
 	memcpy(chunk, &auth->params.eapmsg[pos], mlen);
 	if (rad_put_attr(auth->radius.handle, RAD_EAP_MESSAGE, chunk, mlen) == -1) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_EAP_MESSAGE failed %s",
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_EAP_MESSAGE failed %s",
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	    auth->status = AUTH_STATUS_FAIL;      
     	    return;
@@ -313,7 +313,7 @@
 	    s->sharedsecret,
 	    c->radius_timeout,
 	    c->radius_retries) == -1) {
-		Log(LG_RADIUS, ("[%s] RADIUS: Adding server error: %s", auth->info.lnkname,
+		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Adding server error: %s", auth->info.lnkname,
 		    rad_strerror(auth->radius.handle)));
 		return (RAD_NACK);
         }
@@ -325,7 +325,7 @@
 	    s->sharedsecret,
 	    c->radius_timeout,
 	    c->radius_retries) == -1) {
-		Log(LG_RADIUS, ("[%s] RADIUS: Adding server error: %s", auth->info.lnkname, 
+		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Adding server error: %s", auth->info.lnkname, 
 		    rad_strerror(auth->radius.handle)));
 		return (RAD_NACK);
         }
@@ -469,13 +469,13 @@
     if (request_type == RAD_ACCESS_REQUEST) {
   
 	if ((auth->radius.handle = rad_open()) == NULL) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: rad_open failed", auth->info.lnkname));
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_open failed", auth->info.lnkname));
     	    return (RAD_NACK);
 	}
     } else { /* RAD_ACCOUNTING_REQUEST */
   
 	if ((auth->radius.handle = rad_acct_open()) == NULL) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: rad_acct_open failed", auth->info.lnkname));
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_acct_open failed", auth->info.lnkname));
     	    return (RAD_NACK);
 	}
     }
@@ -483,7 +483,7 @@
     if (conf->file && strlen(conf->file)) {
 	Log(LG_RADIUS2, ("[%s] RADIUS: using %s", auth->info.lnkname, conf->file));
 	if (rad_config(auth->radius.handle, conf->file) != 0) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: rad_config: %s", auth->info.lnkname, 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_config: %s", auth->info.lnkname, 
     		rad_strerror(auth->radius.handle)));
     	    return (RAD_NACK);
 	}
@@ -508,7 +508,7 @@
     return RAD_NACK;
 
   if (rad_create_request(auth->radius.handle, request_type) == -1) {
-    Log(LG_RADIUS, ("[%s] RADIUS: rad_create_request: %s", 
+    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: rad_create_request: %s", 
       auth->info.lnkname, rad_strerror(auth->radius.handle)));
     return (RAD_NACK);
   }
@@ -517,7 +517,7 @@
 	tmpval = conf->identifier;
     } else {
 	if (gethostname(host, sizeof(host)) == -1) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: gethostname() for RAD_NAS_IDENTIFIER failed", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: gethostname() for RAD_NAS_IDENTIFIER failed", 
     		auth->info.lnkname));
 	    return (RAD_NACK);
 	}
@@ -526,7 +526,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_NAS_IDENTIFIER: %s", 
 	auth->info.lnkname, tmpval));
     if (rad_put_string(auth->radius.handle, RAD_NAS_IDENTIFIER, tmpval) == -1)  {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IDENTIFIER failed %s", auth->info.lnkname,
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IDENTIFIER failed %s", auth->info.lnkname,
     	    rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -535,7 +535,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_NAS_IP_ADDRESS: %s", 
       auth->info.lnkname, inet_ntoa(conf->radius_me)));
     if (rad_put_addr(auth->radius.handle, RAD_NAS_IP_ADDRESS, conf->radius_me) == -1) {
-      Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IP_ADDRESS failed %s", 
+      Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IP_ADDRESS failed %s", 
 	auth->info.lnkname, rad_strerror(auth->radius.handle)));
       return (RAD_NACK);
     }
@@ -545,7 +545,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_NAS_IPV6_ADDRESS: %s", 
       auth->info.lnkname, u_addrtoa(&conf->radius_mev6,buf,sizeof(buf))));
     if (rad_put_attr(auth->radius.handle, RAD_NAS_IPV6_ADDRESS, &conf->radius_mev6.u.ip6, sizeof(conf->radius_mev6.u.ip6)) == -1) {
-      Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IPV6_ADDRESS failed %s", 
+      Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_IPV6_ADDRESS failed %s", 
 	auth->info.lnkname, rad_strerror(auth->radius.handle)));
       return (RAD_NACK);
     }
@@ -559,7 +559,7 @@
 	&& request_type != RAD_ACCOUNTING_REQUEST) {
     Log(LG_RADIUS2, ("[%s] RADIUS: Put Message Authenticator", auth->info.lnkname));
     if (rad_put_message_authentic(auth->radius.handle) == -1) {
-      Log(LG_RADIUS, ("[%s] RADIUS: Put message_authentic failed %s", 
+      Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put message_authentic failed %s", 
         auth->info.lnkname, rad_strerror(auth->radius.handle)));
       return (RAD_NACK);
     }
@@ -568,7 +568,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_SESSION_ID: %s", 
 	auth->info.lnkname, auth->info.session_id));
     if (rad_put_string(auth->radius.handle, RAD_ACCT_SESSION_ID, auth->info.session_id) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_SESSION_ID: %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_SESSION_ID: %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -576,7 +576,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_NAS_PORT: %d", 
 	auth->info.lnkname, auth->info.linkID));
     if (rad_put_int(auth->radius.handle, RAD_NAS_PORT, auth->info.linkID) == -1)  {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT failed %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT failed %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -602,7 +602,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_NAS_PORT_TYPE: %d", 
 	auth->info.lnkname, porttype));
     if (rad_put_int(auth->radius.handle, RAD_NAS_PORT_TYPE, porttype) == -1) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT_TYPE failed %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT_TYPE failed %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -610,7 +610,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_SERVICE_TYPE: RAD_FRAMED", 
 	auth->info.lnkname));
     if (rad_put_int(auth->radius.handle, RAD_SERVICE_TYPE, RAD_FRAMED) == -1) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_SERVICE_TYPE failed %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_SERVICE_TYPE failed %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -618,7 +618,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_FRAMED_PROTOCOL: RAD_PPP", 
 	auth->info.lnkname));
     if (rad_put_int(auth->radius.handle, RAD_FRAMED_PROTOCOL, RAD_PPP) == -1) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_PROTOCOL failed %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_PROTOCOL failed %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -628,7 +628,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_STATE: 0x%s", auth->info.lnkname, tmpval));
 	Freee(tmpval);
 	if (rad_put_attr(auth->radius.handle, RAD_STATE, auth->params.state, auth->params.state_len) == -1) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_STATE failed %s", 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_STATE failed %s", 
     		auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	    return (RAD_NACK);
 	}
@@ -639,7 +639,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_CLASS: 0x%s", auth->info.lnkname, tmpval));
 	Freee(tmpval);
 	if (rad_put_attr(auth->radius.handle, RAD_CLASS, auth->params.class, auth->params.class_len) == -1) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_CLASS failed %s", 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_CLASS failed %s", 
     		auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	    return (RAD_NACK);
 	}
@@ -649,7 +649,7 @@
         auth->info.lnkname, auth->params.callingnum));
     if (rad_put_string(auth->radius.handle, RAD_CALLING_STATION_ID,
     	    auth->params.callingnum) == -1) {
-        Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_CALLING_STATION_ID failed %s",
+        Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_CALLING_STATION_ID failed %s",
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	return (RAD_NACK);
     }
@@ -657,7 +657,7 @@
 	auth->info.lnkname, auth->params.callednum));
     if (rad_put_string(auth->radius.handle, RAD_CALLED_STATION_ID,
     	    auth->params.callednum) == -1) {
-    	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_CALLED_STATION_ID failed %s",
+    	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_CALLED_STATION_ID failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	return (RAD_NACK);
     }
@@ -667,7 +667,7 @@
     	auth->info.lnkname, auth->params.peeriface));
 	if (rad_put_string(auth->radius.handle, RAD_NAS_PORT_ID,
 	        auth->params.peeriface) == -1) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT_ID failed %s",
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_NAS_PORT_ID failed %s",
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 		return (RAD_NACK);
 	}
@@ -676,7 +676,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_LINK: %s", 
         auth->info.lnkname, auth->info.lnkname));
     if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_LINK, auth->info.lnkname) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_LINK: %s", auth->info.lnkname,
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_LINK: %s", auth->info.lnkname,
 	    rad_strerror(auth->radius.handle)));
     	return (RAD_NACK);
     }
@@ -685,7 +685,7 @@
 	auth->info.lnkname, auth->info.peer_ident));
     if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD,
       RAD_MPD_PEER_IDENT, auth->info.peer_ident) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_PEER_IDENT failed %s",
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_PEER_IDENT failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -722,7 +722,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_TUNNEL_TYPE: %d", 
 	    auth->info.lnkname, porttype));
 	if (rad_put_int(auth->radius.handle, RAD_TUNNEL_TYPE, porttype) == -1) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_TYPE failed %s", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_TYPE failed %s", 
     		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
 	}
@@ -741,7 +741,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_TUNNEL_MEDIUM_TYPE: %d", 
 	    auth->info.lnkname, porttype));
 	if (rad_put_int(auth->radius.handle, RAD_TUNNEL_MEDIUM_TYPE, porttype) == -1) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_MEDIUM_TYPE failed %s", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_MEDIUM_TYPE failed %s", 
     		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
 	}
@@ -755,7 +755,7 @@
     		auth->info.lnkname, tmpval));
 	    if (rad_put_string_tag(auth->radius.handle, RAD_TUNNEL_SERVER_ENDPOINT,
     		    0, tmpval) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_SERVER_ENDPOINT failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_SERVER_ENDPOINT failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -770,7 +770,7 @@
     		auth->info.lnkname, tmpval));
 	    if (rad_put_string_tag(auth->radius.handle, RAD_TUNNEL_CLIENT_ENDPOINT,
     		    0, tmpval) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_CLIENT_ENDPOINT failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_CLIENT_ENDPOINT failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -785,7 +785,7 @@
     		auth->info.lnkname, tmpval));
 	    if (rad_put_string_tag(auth->radius.handle, RAD_TUNNEL_SERVER_AUTH_ID,
     		    0, tmpval) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_SERVER_AUTH_ID failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_SERVER_AUTH_ID failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -800,7 +800,7 @@
     		auth->info.lnkname, tmpval));
 	    if (rad_put_string_tag(auth->radius.handle, RAD_TUNNEL_CLIENT_AUTH_ID,
     		    0, tmpval) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_CLIENT_AUTH_ID failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_TUNNEL_CLIENT_AUTH_ID failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -813,7 +813,7 @@
     		auth->info.lnkname, auth->params.selfname));
 	    if (rad_put_vendor_string(auth->radius.handle, 3561, 1,
     		    auth->params.selfname) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put ADSL-Agent-Circuit-Id failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put ADSL-Agent-Circuit-Id failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -823,7 +823,7 @@
     		auth->info.lnkname, auth->params.peername));
 	    if (rad_put_vendor_string(auth->radius.handle, 3561, 2,
     		    auth->params.peername) == -1) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put ADSL-Agent-Remote-Id failed %s",
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put ADSL-Agent-Remote-Id failed %s",
     	    	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	    }
@@ -849,7 +849,7 @@
   Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_USER_NAME: %s", 
     auth->info.lnkname, auth->params.authname));
   if (rad_put_string(auth->radius.handle, RAD_USER_NAME, auth->params.authname) == -1) {
-    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME failed %s", 
+    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME failed %s", 
       auth->info.lnkname, rad_strerror(auth->radius.handle)));
     return (RAD_NACK);
   }
@@ -859,7 +859,7 @@
 
       case CHAP_ALG_MSOFT:
 	if (cp->value_len != 49) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: RADIUS_CHAP (MSOFTv1) unrecognised key length %d/%d",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: RADIUS_CHAP (MSOFTv1) unrecognised key length %d/%d",
 	    auth->info.lnkname, cp->value_len, 49));
 	  return (RAD_NACK);
 	}
@@ -868,7 +868,7 @@
 	  auth->info.lnkname));
 	if (rad_put_vendor_attr(auth->radius.handle, RAD_VENDOR_MICROSOFT, RAD_MICROSOFT_MS_CHAP_CHALLENGE,
 	    cp->chal_data, cp->chal_len) == -1)  {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_CHALLENGE failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_CHALLENGE failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
@@ -883,7 +883,7 @@
 	  auth->info.lnkname));
 	if (rad_put_vendor_attr(auth->radius.handle, RAD_VENDOR_MICROSOFT, RAD_MICROSOFT_MS_CHAP_RESPONSE,
 	    &rad_mschapval, sizeof(rad_mschapval)) == -1)  {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_RESPONSE failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_RESPONSE failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
@@ -900,7 +900,7 @@
 	  auth->info.lnkname));
 	if (rad_put_vendor_attr(auth->radius.handle, RAD_VENDOR_MICROSOFT,
 	    RAD_MICROSOFT_MS_CHAP_CHALLENGE, cp->chal_data, cp->chal_len) == -1) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_CHALLENGE failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MICROSOFT_MS_CHAP_CHALLENGE failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
@@ -919,7 +919,7 @@
 	  auth->info.lnkname));
 	if (rad_put_vendor_attr(auth->radius.handle, RAD_VENDOR_MICROSOFT, RAD_MICROSOFT_MS_CHAP2_RESPONSE,
 	    &rad_mschapv2val, sizeof(rad_mschapv2val)) == -1)  {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put vendor_attr(RAD_MICROSOFT_MS_CHAP2_RESPONSE failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put vendor_attr(RAD_MICROSOFT_MS_CHAP2_RESPONSE failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
@@ -932,14 +932,14 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_CHAP_CHALLENGE",
 	  auth->info.lnkname));
 	if (rad_put_attr(auth->radius.handle, RAD_CHAP_CHALLENGE, cp->chal_data, cp->chal_len) == -1) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_CHAP_CHALLENGE failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_CHAP_CHALLENGE failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_CHAP_PASSWORD",
 	  auth->info.lnkname));
 	if (rad_put_attr(auth->radius.handle, RAD_CHAP_PASSWORD, &rad_chapval, cp->value_len + 1) == -1) {
-	  Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_CHAP_PASSWORD failed %s",
+	  Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_CHAP_PASSWORD failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	  return (RAD_NACK);
 	}
@@ -955,7 +955,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_USER_PASSWORD",
       auth->info.lnkname));
     if (rad_put_string(auth->radius.handle, RAD_USER_PASSWORD, pp->peer_pass) == -1) {
-      Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_PASSWORD failed %s", 
+      Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_PASSWORD failed %s", 
 	auth->info.lnkname, rad_strerror(auth->radius.handle)));
       return (RAD_NACK);
     }
@@ -980,7 +980,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: RAD_START", 
     	    auth->info.lnkname));
 	if (rad_put_int(auth->radius.handle, RAD_ACCT_STATUS_TYPE, RAD_START)) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put STATUS_TYPE: %s", 
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put STATUS_TYPE: %s", 
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
     	    return (RAD_NACK);
 	}
@@ -989,7 +989,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_FRAMED_IP_ADDRESS: %s", 
 	auth->info.lnkname, inet_ntoa(auth->info.peer_addr)));
     if (rad_put_addr(auth->radius.handle, RAD_FRAMED_IP_ADDRESS, auth->info.peer_addr)) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_IP_ADDRESS: %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_IP_ADDRESS: %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1000,7 +1000,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_FRAMED_IP_NETMASK: %s", 
 	    auth->info.lnkname, inet_ntoa(ip)));
 	if (rad_put_addr(auth->radius.handle, RAD_FRAMED_IP_NETMASK, ip)) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_IP_NETMASK: %s", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_FRAMED_IP_NETMASK: %s", 
     		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
 	}
@@ -1010,7 +1010,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_USER_NAME: %s", 
 	auth->info.lnkname, username));
     if (rad_put_string(auth->radius.handle, RAD_USER_NAME, username) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME: %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_USER_NAME: %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1018,7 +1018,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_MULTI_SESSION_ID: %s", 
 	auth->info.lnkname, auth->info.msession_id));
     if (rad_put_string(auth->radius.handle, RAD_ACCT_MULTI_SESSION_ID, auth->info.msession_id) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_MULTI_SESSION_ID: %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_MULTI_SESSION_ID: %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1026,7 +1026,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_BUNDLE: %s", 
         auth->info.lnkname, auth->info.bundname));
     if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_BUNDLE, auth->info.bundname) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_BUNDLE: %s", auth->info.lnkname,
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_BUNDLE: %s", auth->info.lnkname,
 	    rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1034,7 +1034,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_IFACE: %s", 
         auth->info.lnkname, auth->info.ifname));
     if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_IFACE, auth->info.ifname) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_IFACE: %s", auth->info.lnkname,
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_IFACE: %s", auth->info.lnkname,
 	    rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1042,7 +1042,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_IFACE_INDEX: %u", 
         auth->info.lnkname, auth->info.ifindex));
     if (rad_put_vendor_int(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_IFACE_INDEX, auth->info.ifindex) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_IFACE_INDEX: %s", auth->info.lnkname,
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_IFACE_INDEX: %s", auth->info.lnkname,
 	    rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1050,7 +1050,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_PEER_IDENT: %s",
 	auth->info.lnkname, auth->info.peer_ident));
     if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_PEER_IDENT, auth->info.peer_ident) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_PEER_IDENT failed %s",
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_PEER_IDENT failed %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1058,7 +1058,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_LINK_COUNT: %d", 
 	auth->info.lnkname, auth->info.n_links));
     if (rad_put_int(auth->radius.handle, RAD_ACCT_LINK_COUNT, auth->info.n_links) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_LINK_COUNT failed: %s", 
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_LINK_COUNT failed: %s", 
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1071,7 +1071,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_AUTHENTIC: %d", 
 	auth->info.lnkname, authentic));
     if (rad_put_int(auth->radius.handle, RAD_ACCT_AUTHENTIC, authentic) != 0) {
-	Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_AUTHENTIC failed: %s",
+	Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_AUTHENTIC failed: %s",
     	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	return (RAD_NACK);
     }
@@ -1088,49 +1088,57 @@
         Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: RAD_STOP", 
 	    auth->info.lnkname));
         if (rad_put_int(auth->radius.handle, RAD_ACCT_STATUS_TYPE, RAD_STOP)) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: %s", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: %s", 
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
         }
-
+       
 	if ((auth->info.downReason == NULL) || (!strcmp(auth->info.downReason, ""))) {
 	  termCause = RAD_TERM_NAS_REQUEST;
-	} else if (!strncmp(auth->info.downReason, STR_MANUALLY, strlen(STR_MANUALLY))) {
-	  termCause = RAD_TERM_ADMIN_RESET;
-	} else if (!strncmp(auth->info.downReason, STR_PEER_DISC, strlen(STR_PEER_DISC))) {
-	  termCause = RAD_TERM_USER_REQUEST;
-	} else if (!strncmp(auth->info.downReason, STR_ADMIN_SHUTDOWN, strlen(STR_ADMIN_SHUTDOWN))) {
-	  termCause = RAD_TERM_ADMIN_REBOOT;
-	} else if (!strncmp(auth->info.downReason, STR_FATAL_SHUTDOWN, strlen(STR_FATAL_SHUTDOWN))) {
-	  termCause = RAD_TERM_NAS_REBOOT;
-	} else if (!strncmp(auth->info.downReason, STR_IDLE_TIMEOUT, strlen(STR_IDLE_TIMEOUT))) {
-	  termCause = RAD_TERM_IDLE_TIMEOUT;
-	} else if (!strncmp(auth->info.downReason, STR_SESSION_TIMEOUT, strlen(STR_SESSION_TIMEOUT))) {
-	  termCause = RAD_TERM_SESSION_TIMEOUT;
-	} else if (!strncmp(auth->info.downReason, STR_DROPPED, strlen(STR_DROPPED))) {
-	  termCause = RAD_TERM_LOST_CARRIER;
-	} else if (!strncmp(auth->info.downReason, STR_ECHO_TIMEOUT, strlen(STR_ECHO_TIMEOUT))) {
-	  termCause = RAD_TERM_LOST_SERVICE;
-	} else if (!strncmp(auth->info.downReason, STR_PROTO_ERR, strlen(STR_PROTO_ERR))) {
-	  termCause = RAD_TERM_SERVICE_UNAVAILABLE;
-	} else if (!strncmp(auth->info.downReason, STR_LOGIN_FAIL, strlen(STR_LOGIN_FAIL))) {
-	  termCause = RAD_TERM_USER_ERROR;
-	} else if (!strncmp(auth->info.downReason, STR_PORT_UNNEEDED, strlen(STR_PORT_UNNEEDED))) {
-	  termCause = RAD_TERM_PORT_UNNEEDED;
-	};
+	} else {
+	   Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_TERM_CAUSE: %s", 
+			    auth->info.lnkname, auth->info.downReason));
+	   if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_TERM_CAUSE, auth->info.downReason) != 0) {
+	      Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_TERM_CAUSE: %s", auth->info.lnkname,
+				     rad_strerror(auth->radius.handle)));
+	   }
+	   if (!strncmp(auth->info.downReason, STR_MANUALLY, strlen(STR_MANUALLY))) {
+	      termCause = RAD_TERM_ADMIN_RESET;
+	   } else if (!strncmp(auth->info.downReason, STR_PEER_DISC, strlen(STR_PEER_DISC))) {
+	      termCause = RAD_TERM_USER_REQUEST;
+	   } else if (!strncmp(auth->info.downReason, STR_ADMIN_SHUTDOWN, strlen(STR_ADMIN_SHUTDOWN))) {
+	      termCause = RAD_TERM_ADMIN_REBOOT;
+	   } else if (!strncmp(auth->info.downReason, STR_FATAL_SHUTDOWN, strlen(STR_FATAL_SHUTDOWN))) {
+	      termCause = RAD_TERM_NAS_REBOOT;
+	   } else if (!strncmp(auth->info.downReason, STR_IDLE_TIMEOUT, strlen(STR_IDLE_TIMEOUT))) {
+	      termCause = RAD_TERM_IDLE_TIMEOUT;
+	   } else if (!strncmp(auth->info.downReason, STR_SESSION_TIMEOUT, strlen(STR_SESSION_TIMEOUT))) {
+	      termCause = RAD_TERM_SESSION_TIMEOUT;
+	   } else if (!strncmp(auth->info.downReason, STR_DROPPED, strlen(STR_DROPPED))) {
+	      termCause = RAD_TERM_LOST_CARRIER;
+	   } else if (!strncmp(auth->info.downReason, STR_ECHO_TIMEOUT, strlen(STR_ECHO_TIMEOUT))) {
+	      termCause = RAD_TERM_LOST_SERVICE;
+	   } else if (!strncmp(auth->info.downReason, STR_PROTO_ERR, strlen(STR_PROTO_ERR))) {
+	      termCause = RAD_TERM_SERVICE_UNAVAILABLE;
+	   } else if (!strncmp(auth->info.downReason, STR_LOGIN_FAIL, strlen(STR_LOGIN_FAIL))) {
+	      termCause = RAD_TERM_USER_ERROR;
+	   } else if (!strncmp(auth->info.downReason, STR_PORT_UNNEEDED, strlen(STR_PORT_UNNEEDED))) {
+	      termCause = RAD_TERM_PORT_UNNEEDED;
+	   }
+	}
+
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_TERMINATE_CAUSE: %s, RADIUS: %d",
 	  auth->info.lnkname, auth->info.downReason, termCause));
-
         if (rad_put_int(auth->radius.handle, RAD_ACCT_TERMINATE_CAUSE, termCause) != 0) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_TERMINATE_CAUSE failed: %s",
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_TERMINATE_CAUSE failed: %s",
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
-        } 
+        }
     } else {
         Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: RAD_UPDATE", 
 	    auth->info.lnkname));
         if (rad_put_int(auth->radius.handle, RAD_ACCT_STATUS_TYPE, RAD_UPDATE)) {
-	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: %s", 
+	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_STATUS_TYPE: %s", 
 		auth->info.lnkname, rad_strerror(auth->radius.handle)));
 	    return (RAD_NACK);
         }
@@ -1139,7 +1147,7 @@
     Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_ACCT_SESSION_TIME: %ld", 
         auth->info.lnkname, (long int)(time(NULL) - auth->info.last_up)));
     if (rad_put_int(auth->radius.handle, RAD_ACCT_SESSION_TIME, time(NULL) - auth->info.last_up) != 0) {
-        Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_SESSION_TIME failed: %s",
+        Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_ACCT_SESSION_TIME failed: %s",
 	    auth->info.lnkname, rad_strerror(auth->radius.handle)));
         return (RAD_NACK);
     }
@@ -1156,7 +1164,7 @@
 	if (rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_OCTETS, auth->info.stats.recvOctets % MAX_U_INT32) != 0 ||
 	    rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_PACKETS, auth->info.stats.recvFrames) != 0 ||
 	    rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_GIGAWORDS, auth->info.stats.recvOctets / MAX_U_INT32) != 0) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put input stats: %s", auth->info.lnkname,
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put input stats: %s", auth->info.lnkname,
 		    rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	}
@@ -1173,7 +1181,7 @@
 	if (rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_OCTETS, auth->info.stats.xmitOctets % MAX_U_INT32) != 0 ||
 	    rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_PACKETS, auth->info.stats.xmitFrames) != 0 ||
 	    rad_put_int(auth->radius.handle, RAD_ACCT_OUTPUT_GIGAWORDS, auth->info.stats.xmitOctets / MAX_U_INT32) != 0) {
-    		Log(LG_RADIUS, ("[%s] RADIUS: Put output stats: %s", auth->info.lnkname,
+    		Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put output stats: %s", auth->info.lnkname,
 		    rad_strerror(auth->radius.handle)));
     		return (RAD_NACK);
 	}
@@ -1186,7 +1194,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_INPUT_OCTETS: %s", 
     	    auth->info.lnkname, str));
 	if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_INPUT_OCTETS, str) != 0) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_INPUT_OCTETS: %s", auth->info.lnkname,
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_INPUT_OCTETS: %s", auth->info.lnkname,
 		rad_strerror(auth->radius.handle)));
 	}
 	snprintf(str, sizeof(str), "%s:%llu",
@@ -1194,7 +1202,7 @@
 	Log(LG_RADIUS2, ("[%s] RADIUS: Put RAD_MPD_INPUT_PACKETS: %s", 
     	    auth->info.lnkname, str));
 	if (rad_put_vendor_string(auth->radius.handle, RAD_VENDOR_MPD, RAD_MPD_INPUT_PACKETS, str) != 0) {
-    	    Log(LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_INPUT_PACKETS: %s", auth->info.lnkname,
+    	    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put RAD_MPD_INPUT_PACKETS: %s", auth->info.lnkname,
 		rad_strerror(auth->radius.handle)));
 	}
 	if (strcmp(ssr->name,auth->params.std_acct[0]) == 0) {
@@ -1207,7 +1215,7 @@
 	    if (rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_OCTETS, ssr->Octets % MAX_U_INT32) != 0 ||
 		rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_PACKETS, ssr->Packets) != 0 ||
 		rad_put_int(auth->radius.handle, RAD_ACCT_INPUT_GIGAWORDS, ssr->Octets / MAX_U_INT32) != 0) {
-    		    Log(LG_RADIUS, ("[%s] RADIUS: Put input stats: %s", auth->info.lnkname,
+    		    Log(LG_ERR|LG_RADIUS, ("[%s] RADIUS: Put input stats: %s", auth->info.lnkname,
 			rad_strerror(auth->radius.handle)));
     		    return (RAD_NACK);
 	    }
